Coin: SoGetMatrixAction Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoGetMatrixAction Class Reference
Action Classes

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph. More...

`#include <Inventor/actions/SoGetMatrixAction.h>`

Inheritance diagram for SoGetMatrixAction:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoGetMatrixAction (const SbViewportRegion &region)
virtual | ~SoGetMatrixAction (void)
void | setViewportRegion (const SbViewportRegion &region)
const SbViewportRegion & | getViewportRegion (void) const
SbMatrix & | getMatrix (void)
SbMatrix & | getInverse (void)
SbMatrix & | getTextureMatrix (void)
SbMatrix & | getTextureInverse (void)
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
virtual void | apply (SoNode *root)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions
virtual const SoEnabledElementsList & | getEnabledElements (void) const
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoGetMatrixAction class is an action for accumulating the transformation matrix of a subgraph.

This action makes it easy to calculate and convert to and from the global coordinate system of your scene and local coordinates of parts in a hierarchical model.

As opposed to most other action types, the SoGetMatrixAction does not traverse children of the node it is applied to – just the node itself. When applied to paths, it stops at the last node and does not continue further with the children of the tail node.

Typical usage when querying for world space position, orientation and/or scaling would be as follows:

// First get hold of an SoPath through the scene graph down to the
// node ("mynode") you want to query about its current world space
// transformation(s).
SoSearchAction * searchaction = new SoSearchAction;
searchaction->setNode(mynode);
searchaction->apply(myscenegraphroot);
SoPath * path = searchaction->getPath();
assert(path != NULL);
// Then apply the SoGetMatrixAction to get the full transformation
// matrix from world space.
const SbViewportRegion vpr = myviewer->getViewportRegion();
SoGetMatrixAction * getmatrixaction = new SoGetMatrixAction(vpr);
getmatrixaction->apply(path);
SbMatrix transformation = getmatrixaction->getMatrix();
// And if you want to access the individual transformation
// components of the matrix:
SbVec3f translation;
SbRotation rotation;
SbVec3f scalevector;
SbRotation scaleorientation;
transformation.getTransform(translation, rotation, scalevector, scaleorientation);
SbMatrix
The SbMatrix class is a 4x4 dimensional representation of a matrix.
Definition SbMatrix.h:47
SbMatrix::getTransform
void getTransform(SbVec3f &t, SbRotation &r, SbVec3f &s, SbRotation &so) const
Definition SbMatrix.cpp:1097
SbRotation
The SbRotation class represents a rotation in 3D space.
Definition SbRotation.h:44
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51
SbViewportRegion
The SbViewportRegion class is a viewport within a full window.
Definition SbViewportRegion.h:40
SoAction::apply
virtual void apply(SoNode *root)
Definition SoAction.cpp:463
SoGetMatrixAction::getMatrix
SbMatrix & getMatrix(void)
Definition SoGetMatrixAction.cpp:168
SoGetMatrixAction::SoGetMatrixAction
SoGetMatrixAction(const SbViewportRegion &region)
Definition SoGetMatrixAction.cpp:126
SoPath
The SoPath class is a container class for traversal path descriptions.
Definition SoPath.h:52
SoSearchAction
The SoSearchAction class provides methods for searching through scene graphs.
Definition SoSearchAction.h:44
SoSearchAction::setNode
void setNode(SoNode *const node)
Definition SoSearchAction.cpp:186
SoSearchAction::getPath
SoPath * getPath(void) const
Definition SoSearchAction.cpp:358

## Constructor & Destructor Documentation

## ◆ SoGetMatrixAction()

SoGetMatrixAction::SoGetMatrixAction | ( | const SbViewportRegion & | region | ) |

Constructor.

The region viewport specification is not used by this action, and is passed along in case it is needed by any nodes.

## ◆ ~SoGetMatrixAction()

SoGetMatrixAction::~SoGetMatrixAction | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoGetMatrixAction::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Implements SoAction.

## ◆ getClassTypeId()

SoType SoGetMatrixAction::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ addMethod()

void SoGetMatrixAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ enableElement()

void SoGetMatrixAction::enableElement | ( | const SoType | type,
|  | const int | stackindex )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getEnabledElements()

const SoEnabledElementsList & SoGetMatrixAction::getEnabledElements | ( | void |  | ) | const
| protectedvirtual

Returns list of enabled elements.

Reimplemented from SoAction.

## ◆ getClassEnabledElements()

SoEnabledElementsList * SoGetMatrixAction::getClassEnabledElements | ( | void |  | ) |
| staticprotected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ getClassActionMethods()

SoActionMethodList * SoGetMatrixAction::getClassActionMethods | ( | void |  | ) |
| staticprotected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ setViewportRegion()

void SoGetMatrixAction::setViewportRegion | ( | const SbViewportRegion & | region | ) |

Set the viewport region.

See also
  SoGetMatrixAction::SoGetMatrixAction()

## ◆ getViewportRegion()

const SbViewportRegion & SoGetMatrixAction::getViewportRegion | ( | void |  | ) | const

Returns the viewport region for the action instance.

## ◆ getMatrix()

SbMatrix & SoGetMatrixAction::getMatrix | ( | void |  | ) |

Returns the accumulated transformation matrix.

Note: don't modify the returned matrix. This should only be done if you are implementing your own transformation type node extensions. This advice is also valid for the other matrix access methods documented below.

## ◆ getInverse()

SbMatrix & SoGetMatrixAction::getInverse | ( | void |  | ) |

Returns the inverse of the accumulated transformation matrix.

## ◆ getTextureMatrix()

SbMatrix & SoGetMatrixAction::getTextureMatrix | ( | void |  | ) |

Returns the accumulated texture matrix.

## ◆ getTextureInverse()

SbMatrix & SoGetMatrixAction::getTextureInverse | ( | void |  | ) |

Returns the inverse of the accumulated texture matrix.

## ◆ beginTraversal()

void SoGetMatrixAction::beginTraversal | ( | SoNode * | node | ) |
| protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

The documentation for this class was generated from the following files:

- SoGetMatrixAction.h
- SoGetMatrixAction.cpp